# Import smtplib for the actual sending function
import smtplib
import subprocess
import time
# Here are the email package modules we'll need
from email.mime.application import MIMEApplication
from email.mime.image import MIMEImage
from email.mime.multipart import MIMEMultipart
from subprocess import call

import grovepi
import cv2
import os

from dht2 import temp
from zipper import zipper

import re


print("System Working")

# Runs the lcd file which displays the temperature and humidity
call("python3 lcd.py", shell=True)

# Hardware components that need to be connected
led_status = 3  # Connect LED Button to port D3
buzzer = 5  # Connect Buzzer to port D5
ranger = 7  # Connect ranger to Port D7

# Setting up Mail
SMTP_USERNAME = "iotg16@outlook.com"  # Mail id of the sender
SMTP_PASSWORD = "Group16!"  # Password of the sender



SMTP_RECIPIENT = input("Please enter the email address the security footage should be sent to: ")  # Mail id of the receiver
    
    
SMTP_SERVER = "smtp.office365.com"  # Address of the SMTP server
SSL_PORT = 587

checker = True
while checker == True:
    print()
    print("The process of adding photos of someone can only be done during startup")
    print()
    face_req = (
        input(
            "Would you like to add photos of someone? No: 0, Yes: 1): "
        )
    )
    
    if face_req == "1" or face_req == "0":
        checker = False
    else:
        checker = True
        print("Invalid Input. Must be 0, 1")
if face_req == "1":
    call("cd facial_recognition; python3 headshots.py", shell=True)

# Code keeps on looping in case of IO Error

sustained = False
sustained_track = 0

while True:
    try:
        while True:
            
            # If something is detected for 250 loops, around 3 seconds, continue.
            # This reduces the chance of random motion triggering the security features.
            while sustained == False:
                
            
                ur_distance = grovepi.ultrasonicRead(ranger)
                
                
                if ur_distance < 100:
                    sustained_track += 1
                    print(sustained_track)
                    print(ur_distance)
                    if sustained_track > 250:
                        sustained = True
                        
                else:
                    sustained_track = 0
                
                
            if ur_distance < 100:  # Runs only if distance is less than 100 cm

                # Prints Temperature and Humidity reading.
                x = temp()
                
                # Turn on the status LED to indicate that someone has arrived or there as been movement
                grovepi.digitalWrite(led_status, 1)
                
                # Make a sound on the Buzzer when movement is detected
                print("Buzzer Activated")
                grovepi.analogWrite(buzzer, 1)
                time.sleep(1)
                grovepi.analogWrite(buzzer, 0)
                print("Buzzer Stopped")

                

                # Take a picture from the Raspberry Pi camera
                # call(["raspistill -o screenshot.jpg -w 640 -h 480 -t 3000"], shell=True)
                # print("Image Shot")

                # Takes video from Pi camera
                call(["raspivid -o myvid.h264 -w 640 -h 480 -t 6000"], shell=True)
                zipper()

                grovepi.digitalWrite(led_status, 0)  # Turn off the LED

                # Running Facial Recognition based on users input
                command = "cd facial_recognition; python3 facial_req.py"
                call(command, shell=True)
                
                
    except IOError:
        print("Error")
        continue

